watch   proc    far
	jmp     install
	endp
										
; Memory-resident program to intercept the timer interrupt and check either
; the printer status and/or modem Carrier Detect Status.  The program was
; originally written by	James R. Reinders and modified by Ray Cannon to	add
; the printer test.  To	install	enter WATCHER <opt>.  The values of <opt> are
; OFF -	to turn	off monitoring of all functions; C1 to monitor carrier on
; port COM1:; C2 to monitor carrier on port COM2:; P1 to monitor LPT1:;
; P2 to monitor LPT2:; P3 to monitor LPT3:; Tn where n is a 1 or 2 digit
; number for how many seconds to wait after the carrier drops before reboot.
; If WATCHER OFF is called before reboot then the timer resets and the
; system reboot is aborted ; thus TnCxPy (no spaces) to monitor both
; carrier on port COMx and printer ready on LPTy for n seconds.

jumpv1  ds      2,0             ; address of prior interrupt
jumpv2  ds      2,0

timval  dw     90               ; five second time out
timout  dw      0               ; time out if watcher off not seen
state   dw      0               ; 0 = off, hi byte = prn#, lo byte = com#

timer				; interrupt code
	push    dx              ; save registers
	push    ax              ; save dx too.
	mov     ax,cs:[offset(state)] ; see if we are to monitor anything
	or	ax,ax
	jz	exitok		; no monitoring
	or      al,al           ; monitor com port?
	jz	monprt		; no try monitor prn
	mov     dx,3FEh         ; load address of COM1:
	dec     al              ; see if al = COM1: ?
	jz      docom           ; done
	mov	dx,2FEh		; load address of COM2:
	dec     al              ; see if al = COM2: ?
	jz      docom           ; done
	mov     dx,3EEh         ; load address of COM3:
	dec     al              ; see if al = COM3: ?
	jz      docom           ; done
	mov     dx,2EEh         ; else put in address for COM4:
docom   in      al,dx           ; get modem status byte
	rcl     al,1            ; shift CD status into Carry
	jb      cdup            ; if CD on then continue
	mov     dx,cs:[offset(timout)] ; see if time out done
	or      dx,dx
	jz      monprt          ; CD has never been on
	cmp     dx,cs:[offset(timval)]
	jz      reboot          ; yes, then re-boot
	incw    cs:[offset(timout)] ; bump by 1
	jmps    monprt          ; no,  continue check LPT
cdup    movw    cs:[offset(timout)],1
monprt  or      ah,ah           ; see if we're to monitor LPT
	jz	exitok		; no, return to	user
	mov     al,ah
	push	ds
	mov	dx,40h		; get DOS data seg
	mov	ds,dx
	shl	al		; mpy lpt # by 2
	add     al,6            ; add in 6
	xor	ah,ah		; zero out ah
	push    si
	mov     si,ax
	mov     dx,[si]         ; get pointer to printer port
	pop     si
	or      dx,dx
	jz      badprt
	inc	dx		; add 1	to get to status port
	in	al,dx		; get status
	and     al,028H         ; mask to get Out of Paper and ERROR
badprt  xor     al,08H          ; flip for status test
	jnz	reboot
	pop	ds
exitok  pop     ax
	pop     dx
	jmpf    cs:jumpv1
; the following nonsense is because the JMP a,b option does not work in
; my version of CHASM
reboot  equ     $
	db      0EAh            ; JMP -  to DOS reboot
	dw      0,0FFFFh

install                         ; start of transient code
	mov     dx,offset(msg)
	mov	ah,09h		; print	sign on
	int	21h

	mov	ax,351Ch	; get timer intrpt
	int	21h
	xor	ax,ax		; zero al
	mov	si,005Dh
	cmpb	[si],'O'	; check	for 'off'
	jnz     ttime
	cmpb    1[si],'F'
	jnz     ttime
	cmpb    2[si],'F'
	jnz     ttime
	cmpb    3[si],' '
	jz	done
ttime   cmpb    [si],'T'        ; Is it time count?
	jnz     numend
	cmpb    1[si],'0'
	jb      numend
	cmpb    1[si],'9'
	ja      numend
	inc     si
	mov     al,[si]
	sub     al,'0'
	cmpb    1[si],'0'
	jb      numend
	cmpb    1[si],'9'
	ja      numend
	inc     si
	mov     cl,10
	mul     cl              ; multiply first digit by 10
	add     al,[si]         ; add in second
	sub     al,'0'          ; subtract bias
numend  mov     cl,18           ; 18 ticks per second
	mul     cl              ; 18 ticks per second
	mov     dx,ax           ; save time to wait
	xor     ax,ax
	inc     si
										
tstco	cmpb	[si],'C'	; test for com port
	jnz	tstpr
	inc	si
	cmpb    [si],'1'
	jb      tstpr
	cmpb    [si],'4'
	ja      tstpr
	movw    cs:[offset(timout)],0
	mov     al,[si]
	sub     al,'0'
	inc	si
tstpr   cmpb    [si],'P'        ; test for printer port
	jnz	done
	inc	si
	cmpb    [si],'1'
	jb	done
	cmpb    [si],'3'
	ja	done
	mov     ah,[si]
	sub     ah,'0'
done	mov	cs:[offset(state)],ax
	inc     dx                      ; add one
	mov     cs:[offset(timval)],dx

finis   seg es
	cmpw	[bx],5052h	; is it	our signature?
	jnz	dome

	dec	bx
	dec	bx
	seg es
	mov     [bx],ax
	dec	bx
	dec	bx
	seg es
	movw    [bx],0
	dec	bx
	dec	bx
	seg es
	mov     [bx],dx
	mov     dx,offset(msg2)
	or	ax,ax
	jnz	pout
	mov     dx,offset(msg3)
pout	mov	ah,09
	int	21h
	int	20h		; bye bye

dome	mov	ax,es		; store	segment
	mov     jumpv2,ax
	mov     jumpv1,bx       ; and offset
	mov	dx,offset(timer)
	mov	ax,251Ch	; new interrupt	pointer
	int	21h
	mov     dx,offset(msg0)
	mov     ax,cs:state
	or      ax,ax
	jnz     dome1
	mov     dx,offset(msg1)
dome1   mov     ah,9
	int	21h

	mov	dx,offset(install)
	inc	dx
	int	27h		; terminate and	stay resident

msg     db 'WATCHER - by Ray Cannon [76314,1775] adopted',10,13
	db '          from WATCHDOG by James R. Reinders',10,13,'$'
msg0    db 'Watcher installed and activated',10,13,'$'
msg1    db 'Watcher installed and deactivated',10,13,'$'
msg2    db 'Watcher activated',10,13,'$'
msg3    db 'Watcher deactivated',10,13,'$'
msg4    db 'Watcher not present OR another time utility loaded since '
	db 'watcher',10,13,'$'
